{$I tttvers.pas}
unit Unmu2;

interface

const ll: array[0..4] of integer = (5,5,16,25,125); //Die Lnge der Felder
      w12 = 1.059463094359295;
      klangfarbe='Klangfarbe';
      Frequenzverhaelnisse1='benachbarte Frequenzverhlnisse';
      Frequenzverhaelnisse2='Frequenzverhlnisse';
      Intervalle1='benachbarte Intervalle';
      Intervalle2='Intervalle';
      AllesBeiIntervallen='Frequenzv. Cent Bez. GG-H OQT';
      InCent='In Cent';
      OktavQuintTerz='[Oktav Quint Terz]';
      Halbtoene='(G G- H)';

var bb: array[0..12] of double;
    stop,schongemeldet:boolean;

procedure liesinsg(const s:string);
procedure berechneFrequenzen(f0:double);
function lieston(const sa:string;var ka:integer; var fein:string;
                 var Oktav:boolean; ta:string):double;
procedure reinton(var f:double;const fein:string);
function TonBezeichnung(auswahl:char; z,n:integer):string;
function ln_(x:real):real; //Tolerant in Cent

implementation

uses sysutils,dialogs,classes,unmu1,jmhilf,jminput; //Tstringlist

procedure setzeKlangfarbe(const s:string);
begin
  with form1 do Begin
    edit1.text:=floatToStr(rr_(s,1));
    edit2.text:=floatToStr(rr_(s,2));
    edit3.text:=floatToStr(rr_(s,3));
    edit4.text:=floatToStr(rr_(s,4));
    edit5.text:=floatToStr(rr_(s,5));
  End;
end;


procedure liesinsg(const s:string);
  var pu:Tstringlist;
       k,k0,j,n:integer;
begin
  pu:=Tstringlist.Create;
  Try
    pu.text:=AdjustLineBreaks(s);
    k0:=0;
    for k:=0 to pu.count-1 do with form1.sg do Begin
      if pos(klangfarbe,pu[k])>0 then Begin
        setzeKlangfarbe(pu[k]);
        continue;
      End;
      if  (pos('^',pu[k])=1) or  //TTW-Datei
          ((k=0) and (pos('TA',pu[k])=1)) then continue;
      inc(k0); //hinkt hinter k her
      if k0>=rowcount then rowcount:=rowcount+2;
      n:=1;
      for j:=0 to 4 do Begin
        cells[j,k0]:=trim(copy(pu[k],n,ll[j]));
        n:=n+ll[j]
      End;
    End;
    with form1.sg do Begin for k:=k0+1 to rowcount-1 do
      for j:=0 to 4 do cells[j,k]:='';
      rowcount:=pu.count+2;
    End;
  finally pu.free End;
  //form1. Rechne1Click(Nil);
end;

procedure berechneFrequenzen(f0:double);
  (* procedure korrigieresyntKomma; begin
      while f0>748 do f0:=f0/2;
      while f0<187 do f0:=f0*2; {fis =748}
      if abs(f0*10/9-bb[0])<1 then f0:=f0*80/81
      {Modulation von c in d ist gT, deshalb von d in c auch!}
   end;*)
begin {Erluterungen C-Dur/Moll mit des und fis}
  //if bb[0]>0 then korrigieresyntKomma;
  bb[0]:=f0;          {c}
  bb[1]:=16/15*bb[0]; {des von c H }
  bb[2]:=9/8*bb[0];   {d   von c gG}
  bb[3]:=6/5*bb[0];   {es  von c kT}
  bb[4]:=5/4*bb[0];   {e   von c gT}
  bb[5]:=4/3*bb[0];   {f   von c q }
  bb[7]:=3/2*bb[0];   {g   von c Q }
  bb[6]:=15/16*bb[7]; {fis von g H }
  bb[8]:=8/5*bb[0];   {as  von c kS}
  bb[9]:=5/3*bb[0];   {a   von c gS}
  bb[10]:=6/5*bb[7];  {b   von g gT} //nach Helmholz S. 450
  //bb[10]:=16/9*bb[0]; // Kirnberger siehe Audite S.60
  bb[11]:=15/8*bb[0]; {h   von c H }
  bb[12]:=2*bb[0]     {c   von c O }
end;

procedure ueberpruefeObErlaubt(t,t1,a,a1:char); //z.B. ob f# in es-Moll enthalten
  procedure melde;
    begin
      if schongemeldet then exit;
      schongemeldet:=true;
      form1.sg.cells[3,0]:='"'+a+a1+'" siehe "Hilfe|Tonbez."';
    end;
begin
  Case t1 of
    ' ':
    CAse t of
      {In c erlaubt: Dur    c  d  e  f  g  a  h  c
                     moll         e*       a* h*
                     Sonder    d*    f#}
      'c':
      CASe a1 of '#': if (a in ['c','d','e','g','a','h']) then melde;
                 '*': if (a in ['c','f','g','b']) then melde;
      END;
      {In g erlaubt: Dur    g  a  h  c  d  e  f#  g
                     moll         h*       e* f
                     Sonder    a*    c#}
      'g':
      CASe a1 of '#': if (a in ['g','a','h','d','e']) then melde; //b#=h
                 '*': if (a in ['g','b','c','d','f']) then melde;
      ENd;
      {In f erlaubt: Dur    f  g  a  b  c  d  e  f
                     moll         a*       d* e*
                     Sonder    g*    h}
      'f':
      CASe a1 of '#': if (a in ['f','g','a','h','c','d','e']) then melde; //b#=h
                 '*': if (a in ['f','b','c']) then melde;
      ENd;
      {In d erlaubt: Dur    d  e  f#  g  a  h  c#  d
                     moll         f         b  c
                     Sonder    e*     g#}
      'd':
      CASe a1 of '#': if (a in ['d','e','a','h']) then melde; //b#=h
                 '*': if (a in ['d','f','g','a','b','c']) then melde;
      End;
      {In b erlaubt: Dur    b  c  d  e*  f  g  a  b
                     moll         d*        g* a*
                     Sonder    c*    e}
      'b':
      CASe a1 of '#': if (a in ['b','h','c','d','e','f','g','a']) then melde;
                 '*': if (a in ['b','f']) then melde;
      END;
      {In a erlaubt: Dur    a  h  c#  d  e  f#  g#  a
                     moll         c         f   g
                     Sonder    h*     d#}
      'a':
      CASe a1 of '#': if (a in ['a','h','e']) then melde;
                 '*': if (a in ['a','b','c','d','e','f','g']) then melde;
      END;
      {In e erlaubt: Dur    e  f#  g#  a  h  c#  d#  e
                     moll          g         c   d
                     Sonder    f       a#}
      'e':
      CASe a1 of '#': if (a in ['e','h']) then melde;
                 '*': if (a in ['e','f','g','a','b','h','c','d']) then melde;
      END;
      {In h erlaubt: Dur    h  c#  d#  e  f#  g#  a#  h
                     moll          d          g   a
                     Sonder    c       e#
       Damit verboten          h#      f}
      'h':
      CASe a1 of ' ': if (a in ['f']) then melde;
                 '#': if (a in ['h']) then melde;
                 '*': if (a in ['h','c','d','e','f','g','a']) then melde;
      END;
    ENd;
    '*':
    CAse t of
      {In e* erlaubt: Dur    e*  f  g  a*  b  c  d  e*
                      moll          g*        c* d*
                      Sonder     f*    a}
      'e':
      CASe a1 of 'h': if (a in ['h']) then melde;
                 '#': if (a in ['e','f','g','a','b','h','c','d']) then melde;
                 '*': if (a in ['b']) then melde;
      END;
      {In a* erlaubt: Dur    a*  b  c  d*  e*  f  g  a*
                      moll          c*         f* g*
                      Sonder     b*    d}
      'a':
      CASe a1 of 'h': if (a in ['h']) then melde;
                 '#': if (a in ['a','b','g','a','b','h','c','d']) then melde;
      END;
    ENd;
  End;
end;


function lieston(const sa:string;var ka:integer; var fein:string;
                 var Oktav:boolean; ta:string):double;
                 //Oktav=true, dann z.B. "a1a1" gleiche Tne sonst "aa"="220 4440"
  {var sa,fein:strg; ka:integerglobal}
  label Feinabstimmung;
  var a{Ton},aOk{Ton mitOktave},a1{Kreuz oder b}:char; Ok{ktavwert}:integer;
   {in sa steht an Stelle ka ton -z.B. a2#- (ais mit feinabst.:-)}
begin
    fein:='';
    if ka>length(sa) then Begin result:=0; exit End;
    repeat
      aOk:=char_(sa,ka);
      a:=char_(lowercase(sa),ka);
      inc(ka)
    until (a<>' ') or  (ka>length(sa));
    Case a of {zunchst wohltemperierte Stimmung}
      'c': result:=130.812782650;
      'd': result:=146.832383959;
      'e': result:=164.813778456;
      'f': result:=174.614115717;
      'g': result:=195.997717901;
      'a': result:=220;
      'b': result:=233.081880759;
      'h': result:=246.941650628;
      else BEgin
        result:=0;
      ENd
    End{Case};
    if (ka<=length(sa)) and (sa[ka] in ['0'..'9']) then Begin
      Oktav:=true;
      Ok:=ord(sa[ka])-48;
      inc(ka)
    End else Begin
      Ok:=0;
      Oktav:=false;
    End;
    if aOk>='a' then Begin
      while Ok>0 do BEgin
        result:=result*2;
        dec(Ok)
      ENd
    End else Begin
      result:=result/2;
      while Ok>0 do BEgin
        result:=result/2;
        dec(Ok)
      ENd
    End;
    a1:=' ';
    Feinabstimmung:
    if ka<=length(sa) then Begin
      if sa[ka]='#' then BEgin
        a1:='#';
        inc(ka);
        result:=result*w12;
        goto Feinabstimmung;
      ENd;
      if sa[ka]='*' then BEgin
        a1:='*';
        inc(ka);
        result:=result/w12;
        goto Feinabstimmung
      ENd;
      if sa[ka] in ['+','-','{','}',',','''','(',')'] then BEgin
      //            synth.Ko 7  11   pyth.K. Leitton
        fein:=fein+sa[ka];
        inc(ka);
        goto Feinabstimmung
      ENd;
    End;
    ueberpruefeObErlaubt(char_(ta,1),char_(ta,2),a,a1);
    (*fein:='';
    while (ka<=length(sa)) and(sa[ka] in ['+','-','}','{','.',':',')','(',']',
                                          '[','&',';','','^','@','+',',']) do Begin
      fein:=fein+sa[ka];
      inc(ka)
    End*)
end;

procedure reinton(var f:double; const fein:string);
  var okt,k:integer; //Oktave
begin
  if f=0 then exit;
  okt:=0;
  while f>=bb[12] do Begin
    dec(okt);
    f:=f/2
  End; {-> f<bb[12]}
  while f<bb[0] do Begin
    inc(okt);
    f:=f*2
  End; {-> f>=bb[0]}
  k:=1;
  while bb[k]<f do inc(k); {->bb[k]<=f<bb[k+1]}
  if abs(f-bb[k-1])<abs(f-bb[k]) then f:=bb[k-1] else f:=bb[k];
  while okt>0 do Begin
    f:=f/2; dec(okt)
  End;
  while okt<0 do Begin
    f:=f*2;
    inc(okt)
  End;
  for k:=1 to length(fein) do Begin
    if fein[k]='{' then f:=f*35/36; //Reine Septime
    if fein[k]='}' then f:=f*33/32;//Alphorn-Fa }
    if fein[k]='+' then f:=f*81/80;//Syntonisches Komma
    if fein[k]='-' then f:=f*80/81;//Syntonisches Komma
    if fein[k]='''' then f:=f*531441/524288; //Pythaororisches Komma
    if fein[k]=','  then f:=f*524288/531441; //Pythagorisches Komma
    if fein[k]='('  then f:=f*15/16;         //Leitton
    if fein[k]=')'  then f:=f*16/15;         //Leitton
  End;
end;

function ln_(x:real):real;
 begin if x<>0 then result:=ln(abs(x)) else result:=0 end;
//Auswahl=' ' (Intervalle) '[' oder '(' oder &=Umrechnung

function TonBezeichnung(auswahl:char; z,n:integer):string;
           var v1,v2,v3,z0,n0:integer;
      function IntToStr_(a:integer):string;
      begin
        result:=IntToStr(a);
        if length(result)<2 then result:=' '+result;
      end;
      function umr(a,b,c:integer):string; var d,e,f:integer; s:string;
           {Rechnet gG/kG/H um in Oktav-Quint-Tertz}
      begin {d:=-a+b+c;} e:=2*a-2*b-c; f:=b-c;
            {Korrektur Oktaven d: Aus z/n=2^d*(3/2)^e(5/4)^f folgt:}
        d:=round((ln_(z0/n0)+e*ln(2/3)+f*ln(4/5))/ln(2));{logar Fehlertolerant}
        s:='';
        if pos('[',auswahl)>0 then s:=s+'['+IntToStr_(d)+IntToStr_(e)+IntToStr_(f)+']';
        if pos('(',auswahl)>0 then s:=s+'('+IntToStr(v1)+IntToStr(v2)+IntToStr(v3)+')';
        result:=s
      end;
      function bruch_q:string;
        begin
          result:= ' '+IntToStr(z0)+'/'+IntToStr(n0)+' '
        end;
      function P_Ok: string;
        begin
          if z0=n0 then result:='P ' else Result:='Ok '
        end;
begin
  z0:=z;
  n0:=n;
  v1:=0;
  v2:=0;
  v3:=0;
  if (z=0) or (n=0) then exit;
  while (z mod 2=0) do z:=z div 2;
  while (n mod 2=0) do n:=n div 2;
  while (n mod 3=0) do Begin n:=n div 3; inc(v1); inc(v2); inc(v3) End;
  while (z mod 3=0) do Begin z:=z div 3; inc(v1,2); inc(v2); inc(v3) End;
  while (z mod 5=0) do Begin z:=z div 5; inc(v1); inc(v2) End;
         {kleine Sext(+ Quart-Oktav=Halbton; (212)+(111)-(322)=(001)}
  while (n mod 5=0) do Begin n:=n div 5; inc(v1,2); inc(v2); inc(v3,2) End;
  {Minus Oktav->} while (v1>2) and (v2>1) and (v3>1) do Begin
    dec(v1,3);
    dec(v2,2);
    dec(v3,2)
  End;
  if (z<>1) or (n<>1) then Begin result:=bruch_q; exit End;
  if Auswahl in ['[','('] then Begin
    result:=umr(v1,v2,v3);
    exit End;
  result:=bruch_q;
  // showmessage(intToStr(v1)+'#'+inttoStr(v2)+'#'+inttoStr(v3));
  Case v1 of 0:
    CAse v2 of 0:{v2}
      CASe v3 of 0:result:=P_Ok;
                 1:result:='H';
                  2:result:='vT(~f#a*)'
      END;
               1:{v2}
      CASe v3 of 0:result:='G-';
                 1:result:='kT-'
      END
    ENd;
             1:{v1}
    CAse v2 of 0:{v2}
      CASe v3 of 0:result:='G';
                   1:result:='kT';
                   2:result:='vq(~he*)'
      END;
               1:{v2}
      CASe v3 of 0:result:='gT';
                   1:result:='q';
                   2:result:='vQ(~hf)';
                   3:result:='vs(~f#d*)';

      END;
               2:{v2}
        CASE v3 of 0:result:='q-';
                   1:result:='Q-';
                   2:result:='ks-'
        END
    ENd;
             2:{v1}
    CAse v2 of 0:{v2}
      CASe v3 of 0:result:='gT+';
                   1:result:='q+';
                   2:result:='vQ(~ae*)'
      END;
               1:{v2}
      CASe v3 of 0:result:='q(~fh)';
                   1:result:='Q';
                   2:result:='ks';
                   3:result:='vS'
      END;
               2:{v2}
      CASe v3 of 0:result:='Q(~a*e)';
                   1:result:='gs';
                   2:result:='kS' ;
                   3:result:='gS(~f#f)'
      END;
               3:{v2}
        CASE v3 of 1:result:='gS(~ba)';
                   3:result:='H-'
      END
    ENd;
             3:{v1}
    CAse v2 of 1:{v2}
      CASe v3 of 1:result:='gs+';
                   2:result:='kS+';
                   3:result:='gS(~aa*)'
      END;
               2:{v2}
      CASe v3 of 0:result:='vS(d*h)';
                   1:result:='gS';
                   2:result:='Ok';
      END;
               3:{v2}
      CASe v3 of 1:result:='H(~a*a)'
      END;
    ENd;
             4:{v1}
    CAse v2 of 1:{v2}
      CASE v3 of 1: result:='gS(Ok-H-)';
                 3: result:='H+'
      END;
               2:{v2}
      CASe v3 of 1: result:='H(~f*f#)';
      END;
               3:{v2}
      CASe v3 of 1: result:='G(~e*f#)';
      END;
    ENd;
             5:{v1}
    CAse v2 of 3:{v2}
      CASE v3 of 1: result:='T(~d*f#)';
      END;
    ENd;
  End;                                     
  while z0>2*n0 do Begin
    n0:=n0*2;
    result:='Ok*'+result
  End;
end;






end.
