{$I tttvers.pas}
{ Eine selbstgeschriebene inputbox.
  ok       :Nur die Ausgabe einer Nachricht.
  jminput1 :Eingabe in einem Feld mit Platz fr einen langen Kommentar
  jmmnput2 :Eingabe in zwei Feldern mit Platz fr einen langen Kommentar
  --------------------------
  Rckgabewer true ("OK") und false ("Abbrechen") ber provate Vraible ok:boolean

  Stichworte: Form zur Laufzeit erzeugen
              showmodal
}

unit jminput;
//in "Projekt|Optionen|Formulare" Form9 zu "verfgbare Formulare" schieben!


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type TOkResult=(Okbestaetigt, OkabbrechenBestaetigt, Okdruckenbestaetigt);
     TOkEingang=(AbrechenNichtSichtbar,AbrrechenAbrechen,AbrechenDrucken);

type
  TForm15 = class(TForm)
    Edit2: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    BOk: TButton;
    BAbbrechen: TButton;
    ComboBox1: TComboBox;
    procedure BOkClick(Sender: TObject);
    procedure BAbbrechenClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    OkResult:TOkResult;
    Buttons: array of TButton;
    ButtonsNr:integer;
  public
    { Public-Deklarationen }
  end;


const BAbbrechenCaptionDrucken='Drucken';
var form15:TForm15;


function ok(const titel,s:string; OkEingang:TokEingang):Tokresult;
procedure okp(const titel,s:string);
procedure oktest(const s:string); overload; //Testmarken sollen schnell gefunden werden
procedure oktest(const r:Extended); overload;
//Ausdruck nur zu Testzwecken fr Programmierer zum besseren Auffinden und lschen

function jminput1(const caption,ueberschrift,Erlaeuterung:string;
                  var eing:string; var comboboxliste:Tstringlist):boolean;
function jminput2(const caption,ueberschrift1,ueberschrift2,Erlaeuterung:string;
                   var eing1,eing2:string):boolean;
function jmdialog(Const ueberschrift,Erlaeuterung,Beschriftung:string):boolean;
procedure UeberWarteSchlangeDrucken(DiesenText: string);
implementation
  uses  winspool, jmhilf,jmmath, Unmu1;

{$R *.DFM}

procedure TextinMemo(const s:string); //vor showmodal
   var k,z:integer;
begin
  with form15 do Begin
    if s='' then BEgin
      height:=height-memo1.height;
      memo1.Hide;
    ENd else BEgin
      memo1.Show;
      memo1.text:=AdjustLineBreaks(s);
    ENd;
    //Zeilen zhlen
    z:=0;
    for k:=1 to length(s) do if s[k]=#13 then inc(z);
    font.size:=10; //Sicherstellen, dass positiv
    height:=height+Form15.memo1.Font.size*z*2;
    if length(s)>720 then height:=screen.Height;
    top:=(screen.Height-height) div 2;
    left:=(screen.width-width) div 2;
  End;
end;

function ok(const titel,s:string; OkEingang:TokEingang):Tokresult;
begin
  form15:=Tform15.Create(Form1);
  try
  with form15 do Begin
    bok.show;
    Case OkEingang of
      AbrechenNichtSichtbar: Babbrechen.Hide;
      AbrrechenAbrechen:
        BEgin
          Babbrechen.Show;
          Babbrechen.Caption:='Abbrechen';
        ENd;
      AbrechenDrucken:
        BEgin
          Babbrechen.Show;
          Babbrechen.Caption:=BAbbrechenCaptionDrucken;
        ENd;
    End;
    label1.hide;
    ComboBox1.hide;
    label2.hide;
    edit2.hide;
    memo1.top:=bok.top+bOk.height+20;
    height:=memo1.top+memo1.height+50;
    memo1.height:=height-memo1.top-40;
    caption:=titel;
    TextinMemo(s);
    SetBounds(20,20,screen.width-40,screen.height-40);
    showmodal;
    result:=form15.OkResult;
  End;
  Finally form15.Free End;
end;

function jmdialog(Const ueberschrift,Erlaeuterung,Beschriftung:string):Boolean;
  var n:integer;
      wort:string;
begin
  form15:=Tform15.Create(Form1);
  try
  with form15 do Begin
    bok.hide; //An diese Stelle die buttons
    n:=0;
    repeat
      wort:=wort_n(Beschriftung,n+1);
      if wort>'' then BEgin
        setlength(buttons,n+1);
        buttons[n]:=Tbutton.Create(Nil);
        buttons[n].parent:=Form15;
        buttons[n].top:=bok.Top;
        buttons[n].height:=Bok.Height;
        if n=0 then buttons[n].left:=bok.Left else
          buttons[n].left:=buttons[n-1].left+buttons[n-1].width+10;
        buttons[n].Width:=max(length(wort)*10,50);
        buttons[n].caption:=wort;
        buttons[n].OnClick:=Form15.Bok.OnClick;
        inc(n);
      ENd;
      bAbbrechen.Hide;
      {bAbbrechen.show;
      bAbbrechen.left:=buttons[n-1].left+buttons[n-1].width+10;}
    until wort='';
    label1.hide;
    ComboBox1.hide;
    label2.hide;
    edit2.hide;
    memo1.top:=bok.top+bOk.height+20;
    height:=memo1.top+memo1.height+50;
    memo1.height:=height-memo1.top-40;
    caption:=ueberschrift;
    TextinMemo(Erlaeuterung);
    showmodal;
    result:=(Form15.OkResult=Okbestaetigt);
  End;
  Finally form15.Free End;
end;




function okf(const titel,s:string):Tokresult;
begin result:=ok(titel,s,AbrrechenAbrechen) end;

procedure okp(const titel,s:string);
begin
  ok(titel,s,AbrechenDrucken);
end;

procedure oktest(const s:string); overload;
begin okp('',s) end;

procedure oktest(const r:Extended); overload;
begin okp('',FloatToStr(r)) end;

function jminput1(const caption,ueberschrift,Erlaeuterung:string;var eing:string;
                  var comboboxliste:Tstringlist):boolean;
  var k:integer;
begin
  form15:=Tform15.Create(Form1);
  try
  if caption='' then Form15.caption:='Eingabe' else
    Form15.caption:=caption;
  with Form15 do Begin
    bok.Show;
    babbrechen.Show;
    label1.Show;
    label1.Caption:=ueberschrift;
    label2.hide;
    ComboBox1.show;
    ComboBox1.text:=eing;
    for k := 0 to comboboxliste.Count -1 do combobox1.Items.Add(comboboxliste[k]);
    edit2.hide;
    memo1.top:=ComboBox1.top+ComboBox1.height+20;
    Height:=screen.Height*3 div 4;
    memo1.height:=height-memo1.top-40;
    TextinMemo(Erlaeuterung);
    showmodal;
    if Form15.okResult=Okabbrechenbestaetigt then result:=false else result:=true;
    if result then BEgin
      if eing <> ComboBox1.text then BEGin
        eing:=ComboBox1.text;
        comboboxliste.Add('');
        for k := comboboxliste.Count - 1 downto 1 do
          comboboxliste[k] := comboboxliste[k-1];
        comboboxliste[0] := eing ;
        while comboboxliste.count > MerkeAnzahl do
         comboboxliste.Delete(comboboxliste.Count -1 );
      END;
    ENd;
  End;
  Finally form15.Free End;
end;

function jminput2(const caption,ueberschrift1,ueberschrift2,Erlaeuterung:string;
                   var eing1,eing2:string):boolean;
begin
  form15:=Tform15.Create(Form1);
  try
  if caption='' then Form15.caption:='Eingabe' else
    Form15.caption:=caption;
  with Form15 do Begin
    bok.Show;
    babbrechen.Show;
    label1.Show;
    label1.Caption:=ueberschrift1;
    label2.Show;
    label2.Caption:=ueberschrift2;
    ComboBox1.show;
    ComboBox1.text:=eing1;
    edit2.show;
    edit2.text:=eing2;
    memo1.top:=edit2.top+edit2.height+20;
    Height:=screen.Height*3 div 4;
    memo1.height:=height-memo1.top-40;
    TextinMemo(Erlaeuterung);
    showmodal;
    if Form15.okResult=Okabbrechenbestaetigt then result:=false else result:=true;
    if result then BEgin
      eing1:=ComboBox1.text;
      eing2:=edit2.text;
    ENd;
  End;
  Finally form15.Free End;
end;

procedure TForm15.BOkClick(Sender: TObject);
  var n:integer;
begin
  SonderfallTTMusikEdierenFertig;
  OkResult:=Okbestaetigt;
  for n:=0 to length(buttons)-1 do
   if sender as Tbutton = buttons[n] then ButtonsNr:=n;
  close;
end;

procedure UeberWarteSchlangeDrucken(DiesenText: string);
       //z.B.'Hallo Welt'#13#10'SeiteRaus'#12
       //uses winspool not forget!
var printer: array[0..255] of char;
    DiesenTextASCII:String;
  procedure RawDataToPrinter(const szPrinterName: string; const data: string; dwCount: DWORD);
  var hPrinter: THandle; DocInfo: TDocInfo1; dwBytesWritten: DWORD;
  begin
    if OpenPrinter(pchar(szPrinterName), hPrinter, Nil) then try
       // Fill in the structure with info about this "document"
      if DiesenText = #12 then DocInfo.pDocName := 'TTMusik Seite auswerfen' else
        DocInfo.pDocName := Pchar('TTMusik');
      DocInfo.pOutputFile := Nil;
      DocInfo.pDatatype := 'RAW'; //Wichtig
       // Inform the spooler the document is beginning
      if StartDocPrinter(hPrinter, 1, @docInfo) <> 0 then Try
        if StartPagePrinter(hPrinter) then TRy
          if WritePrinter(hPrinter, Pchar(data), dwCount, dwBytesWritten) then
            if dwBytesWritten <> dwCount then showmessage('Fehler beim Drucken');
        FInally EndPagePrinter(hPrinter) ENd;
      Finally EndDocPrinter(hPrinter) End;
    finally ClosePrinter(hPrinter) end;
  end;
begin
  GetProfileString('windows', 'device', ',,,', printer, sizeof(printer));
  if Pos(',', printer) > 0 then printer[Pos(',', printer) - 1] := #0;
  Setlength(DiesenTextASCII,length(DiesenText));
  CharToOem(Pchar(DiesenText),Pchar(DiesenTextASCII));
  RawDataToPrinter(printer, DiesenTextASCII, length(DiesenTextASCII));
end;

procedure TForm15.BAbbrechenClick(Sender: TObject);
begin
  OkResult:=OkabbrechenBestaetigt;
  if Babbrechen.Caption=BAbbrechenCaptionDrucken then Begin
      UeberWarteSchlangeDrucken(memo1.text);
    showmessage('Sie knnen mehrere Texte auf eine Seite drucken.'#13+
                'Wenn fertig: Men "Datei|Seite auswerfen"!');
  End else close;
end;

procedure TForm15.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then if edit2.Visible then edit2.SetFocus else
     BOkClick(Nil);
end;

procedure TForm15.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
   if key=#13 then BOkClick(Nil);
end;

procedure TForm15.FormDestroy(Sender: TObject);
  var n:integer;
begin
  for n:=0 to length(buttons)-1 do buttons[n].free;
  setlength(buttons,0);
  //BAbbrechen.left:=Bok.left+Bok.width+20;
end;


procedure TForm15.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#27 then if babbrechen.Caption<>BAbbrechenCaptionDrucken
   then BAbbrechenClick(Nil) else BokClick(nil);
end;

procedure TForm15.FormCreate(Sender: TObject);
begin
  OkResult := OkabbrechenBestaetigt; //Falls auf X geklickt
end;

procedure TForm15.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 13 then BOkClick(nil);
end;

end.
